#include <iostream>
#include <vector>
#include <cstdlib>
#include <unistd.h>
#include <signal.h>

#include "RtMidi.h"

using namespace std;

bool done;

static void finish(int ignore) { done = 1;}

int main()
{
    RtMidiOut *midiout = 0;
    int portNumber = 1;
    vector<unsigned char> message;

    try {
        midiout = new RtMidiOut();
    } catch (RtMidiError &error) {
        error.printMessage();
        return -1;
    }

    midiout->openPort(portNumber);

    cout << "Writing MIDI to port : " << midiout->getPortName(portNumber) << endl;

    message.clear();
    message.push_back(0xB0);
    message.push_back(32);
    message.push_back(127);

    midiout->sendMessage(&message);

    for (int i = 0; i < 5; i ++ ) {
        message.clear();
        message.push_back(0x90);
        message.push_back(60);
        message.push_back(127);

        midiout->sendMessage(&message);
        message.clear();
        message.push_back(0xB0);
        message.push_back(32);
        message.push_back(127);

        midiout->sendMessage(&message);

        sleep(1);
        message.clear();
        message.push_back(0x90);
        message.push_back(60);
        message.push_back(0);

        midiout->sendMessage(&message);

        message.clear();
        message.push_back(0xB0);
        message.push_back(32);
        message.push_back(0);

        midiout->sendMessage(&message);
        sleep(1);
    }

cleanup:
    midiout->closePort();
    delete midiout;
    cout << "Done." << endl;

    return 0;
}

